Package net.sf.saxon.pattern

## Class CombinedNodeTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.pattern.CombinedNodeTest

- All Implemented Interfaces:
    `java.util.function.Predicate<NodeInfo>`, `ItemType`, `ItemType.WithSequenceTypeCache`

      public class CombinedNodeTest
      extends NodeTest

  A CombinedNodeTest combines two node tests using one of the operators union (=or), intersect (=and), difference (= "and not"). This arises when optimizing a union (etc) of two path expressions using the same axis. A CombinedNodeTest is also used to support constructs such as element(N,T), which can be expressed as (element(N,*) intersect element(*,T))

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CombinedNodeTest​(NodeTest nt1, int operator, NodeTest nt2)` | Create a NodeTest that combines two other node tests

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addTypeDetails​(DictionaryMap map)` | Add the "parameters" of the type to a Dictionary containing the type information in structured form
    `boolean` | `equals​(java.lang.Object other)` | Indicates whether some other object is "equal to" this one.
    `java.util.Optional<java.lang.String>` | `explainMismatch​(Item item, TypeHierarchy th)` | Get extra diagnostic information about why a supplied item does not conform to this item type, if available.
    `AtomicType` | `getAtomizedItemType()` | Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
    `NodeTest[]` | `getComponentNodeTests()` | Get the two parts of the combined node test
    `SchemaType` | `getContentType()` | Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
    `java.lang.String` | `getContentTypeForAlphaCode()` |
    `double` | `getDefaultPriority()` | Get the default priority of this nodeTest when used as a pattern.
    `int` | `getFingerprint()` | Get the name of the nodes matched by this nodetest, if it matches a specific name.
    `java.util.function.IntPredicate` | `getMatcher​(NodeVectorTree tree)` | Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test.
    `StructuredQName` | `getMatchingNodeName()` | Get the name of the nodes matched by this nodetest, if it matches a specific name.
    `NodeTest` | `getOperand​(int which)` |
    `int` | `getOperator()` | Get the operator used to combine the two node tests: one of `Token.UNION`, `Token.INTERSECT`, `Token.EXCEPT`,
    `int` | `getPrimitiveType()` | Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
    `java.util.Optional<IntSet>` | `getRequiredNodeNames()` | Get the set of node names allowed by this NodeTest.
    `UType` | `getUType()` | Get the corresponding `UType`.
    `int` | `hashCode()` | Returns a hash code value for the object.
    `boolean` | `isAtomizable​(TypeHierarchy th)` | Ask whether values of this type are atomizable
    `boolean` | `isNillable()` | Determine whether the content type (if present) is nillable
    `boolean` | `matches​(int nodeKind, NodeName name, SchemaType annotation)` | Test whether this node test is satisfied by a given node.
    `boolean` | `test​(NodeInfo node)` | Test whether this node test is satisfied by a given node.
    `java.lang.String` | `toExportString()` | Return a string representation of this ItemType suitable for use in stylesheet export files.
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `copy, getBasicAlphaCode, getGenre, getPrimitiveItemType, isAtomicType, isPlainType, matches, one, oneOrMore, toShortString, zeroOrMore, zeroOrOne`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getFullAlphaCode, getNormalizedDefaultPriority, isTrueItemType`

    - ### Methods inherited from interface java.util.function.Predicate

      `and, negate, or`

- - ### Constructor Detail

    - #### CombinedNodeTest

          public CombinedNodeTest​(NodeTest nt1,
                                  int operator,
                                  NodeTest nt2)

      Create a NodeTest that combines two other node tests
      Parameters:
        `nt1` - the first operand. Note that if the defaultPriority of the pattern is required, it will be taken from that of the first operand.
        `operator` - one of Token.UNION, Token.INTERSECT, Token.EXCEPT
        `nt2` - the second operand

  - ### Method Detail

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Returns:
        the smallest UType that subsumes this item type

    - #### matches

          public boolean matches​(int nodeKind,
                                 NodeName name,
                                 SchemaType annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node test

    - #### getMatcher

          public java.util.function.IntPredicate getMatcher​(NodeVectorTree tree)

      Description copied from class: `NodeTest`
      Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test. (Calling this matcher must give the same result as calling `matchesNode(tree.getNode(nodeNr))`, but it may well be faster).
      Overrides:
        `getMatcher` in class `NodeTest`
      Parameters:
        `tree` - the tree against which the returned function will operate
      Returns:
        an IntPredicate; the matches() method of this predicate takes a node number as input, and returns true if and only if the node identified by this node number matches the node test.

    - #### test

          public boolean test​(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Specified by:
        `test` in interface `java.util.function.Predicate<NodeInfo>`
      Overrides:
        `test` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`

    - #### toExportString

          public java.lang.String toExportString()

      Return a string representation of this ItemType suitable for use in stylesheet export files. This differs from the result of toString() in that it will not contain any references to anonymous types. Note that it may also use the Saxon extended syntax for union types and tuple types. The default implementation returns the result of calling `toString()`.
      Returns:
        the string representation as an instance of the XPath SequenceType construct

    - #### getContentTypeForAlphaCode

          public java.lang.String getContentTypeForAlphaCode()

    - #### addTypeDetails

          public void addTypeDetails​(DictionaryMap map)

      Add the "parameters" of the type to a Dictionary containing the type information in structured form

    - #### getPrimitiveType

          public int getPrimitiveType()

      Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the node kind matched by this node test

    - #### getRequiredNodeNames

          public java.util.Optional<IntSet> getRequiredNodeNames()

      Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. IntUniversalSet indicates that all names are permitted (i.e. that there are no constraints on the node name).
      Overrides:
        `getRequiredNodeNames` in class `NodeTest`
      Returns:
        the set of integer fingerprints of the node names that this node test can match; or absent if the set of names cannot be represented (for example, with the name tests *:xxx or xxx:*)

    - #### getContentType

          public SchemaType getContentType()

      Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.
      Overrides:
        `getContentType` in class `NodeTest`
      Returns:
        the type annotation that all nodes matching this NodeTest must satisfy

    - #### getAtomizedItemType

          public AtomicType getAtomizedItemType()

      Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Overrides:
        `getAtomizedItemType` in class `NodeTest`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### isAtomizable

          public boolean isAtomizable​(TypeHierarchy th)

      Ask whether values of this type are atomizable
      Specified by:
        `isAtomizable` in interface `ItemType`
      Overrides:
        `isAtomizable` in class `NodeTest`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        true unless it is known that these items will be elements with element-only content, in which case return false

    - #### getFingerprint

          public int getFingerprint()

      Get the name of the nodes matched by this nodetest, if it matches a specific name. Return -1 if the node test matches nodes of more than one name
      Overrides:
        `getFingerprint` in class `NodeTest`

    - #### getMatchingNodeName

          public StructuredQName getMatchingNodeName()

      Description copied from class: `NodeTest`
      Get the name of the nodes matched by this nodetest, if it matches a specific name. Return null if the node test matches nodes of more than one name
      Overrides:
        `getMatchingNodeName` in class `NodeTest`

    - #### isNillable

          public boolean isNillable()

      Determine whether the content type (if present) is nillable
      Overrides:
        `isNillable` in class `NodeTest`
      Returns:
        true if the content test (when present) can match nodes that are nilled

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals​(java.lang.Object other)

      Indicates whether some other object is "equal to" this one.
      Overrides:
        `equals` in class `java.lang.Object`

    - #### getDefaultPriority

          public double getDefaultPriority()

      Get the default priority of this nodeTest when used as a pattern. In the case of a union, this will always be (arbitrarily) the default priority of the first operand. In other cases, again somewhat arbitrarily, it is 0.25, reflecting the common usage of an intersection to represent the pattern element(E, T).
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Specified by:
        `getDefaultPriority` in class `NodeTest`
      Returns:
        the default priority for the pattern

    - #### getComponentNodeTests

          public NodeTest[] getComponentNodeTests()

      Get the two parts of the combined node test
      Returns:
        the two operands

    - #### getOperator

          public int getOperator()

      Get the operator used to combine the two node tests: one of `Token.UNION`, `Token.INTERSECT`, `Token.EXCEPT`,
      Returns:
        the operator

    - #### getOperand

          public NodeTest getOperand​(int which)

    - #### explainMismatch

          public java.util.Optional<java.lang.String> explainMismatch​(Item item,
                                                                      TypeHierarchy th)

      Get extra diagnostic information about why a supplied item does not conform to this item type, if available. If extra information is returned, it should be in the form of a complete sentence, minus the closing full stop. No information should be returned for obvious cases.
      Specified by:
        `explainMismatch` in interface `ItemType`
      Overrides:
        `explainMismatch` in class `NodeTest`
      Parameters:
        `item` - the item that doesn't match this type
        `th` - the type hierarchy cache
      Returns:
        optionally, a message explaining why the item does not match the type